/*****************************************************************************
 *  INCLUDE FILE(S)
 *  ---------------
 *	This .cpp file should automatically include all the support files needed
 *	for this particular class. In addition, this file may include other .h
 *	files defining additional callback interfaces for use by a third party.   
 ****************************************************************************/ 

//#define PDF_THROWS_CPP_EXCEPTIONS

/* -- INCLUDES ---------------------------------------------------------- */

#include <stdio.h>
#include <direct.h>
//#include <fstream.h>
#include <iostream>


#ifndef _H_cscript
	#include "PsxScrp.h"
#endif
#include "mui.h"
#include "pdflib.hpp"


/* -- MACRO DEFINITIONS ------------------------------------------------- */


// ERROR CODES
#define NO_ERR 0
#define OUTPUT_ERR 1
#define INIT_ERR 2
#define IMG_ERR	3


#define TEXT_ERR 1
#define PATTERN_ERR 2
#define OTHER_ERR 10



/* -- DECLARATIONS ------------------------------------------------------ */


/* -- VARIABLES --------------------------------------------------------- */

bool dbg = false;


PIMoaMmValue        pVal;
PIMoaDrPlayer       pPlayer;

char buf[256];

PDFlib p;
//PDFlib *pp;


/* -- FUNCTIONS --------------------------------------------------------- */

//###########################################################################
// DEBUGGING UTILITIES
//###########################################################################
void dbgi(int n)
{
	char buf[256];
	sprintf(buf, "%d", n);
	MessageBoxA (NULL, buf, "INFO", 0);
}
/*********************************************************************/

void dbgs(const char* s)
{
	char buf[512];
	strcpy(buf,s);
	strcat(buf, "\n");
	//pUtil->PrintMessage(buf);

	MessageBoxA (NULL, s, "INFO", 0);

	// MUI ALERT
	// pAlert->Alert(s, "INFO", kMuiAlertButtons_Ok, 1, kMuiAlertIcon_None);
}

/*********************************************************************/
char *replace(char *string, char *oldpiece, char *newpiece) 
{ 
   int str_index, newstr_index, oldpiece_index, end, new_len, old_len, cpy_len; 
   char *c; 
   static char newstring[MAX_PATH + 1]; 

   if ((c = (char *) strstr(string, oldpiece)) == NULL)  return string; 

   new_len = strlen(newpiece); 
   old_len = strlen(oldpiece); 
   end = strlen(string) - old_len; 
   oldpiece_index = c - string; 

   newstr_index = 0; 
   str_index = 0; 
   while(str_index <= end && c != NULL) 
   { 
      /* Copy characters from the left of matched pattern occurence */ 
      cpy_len = oldpiece_index-str_index; 
      strncpy(newstring+newstr_index, string+str_index, cpy_len); 
      newstr_index += cpy_len; 
      str_index += cpy_len; 

      /* Copy replacement characters instead of matched pattern */ 
      strcpy(newstring+newstr_index, newpiece); 
      newstr_index += new_len; 
      str_index += old_len; 

      /* Check for another pattern match */ 
      if((c = (char *) strstr(string+str_index, oldpiece)) != NULL) 
         oldpiece_index = c - string; 
   } 
   /* Copy remaining characters from the right of last matched pattern */ 
   strcpy(newstring+newstr_index, string+str_index); 

   return newstring; 
} 


/*****************************************************************************
 *  Private Methods
 *  -------------------
 *  Implementation of Private Class Methods
 ****************************************************************************/

//###########################################################################
// GENERAL
//###########################################################################

//---------------------------------------------------------------
// SET_PARAMETER // p.set_parameter("compatibility","1.4");
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_set_parameter(PMoaDrCallInfo callPtr)
{
	////MoaError err = kMoaErr_NoErr;
	
	MoaMmValue kValue = {0};
	MoaMmValue vValue = {0};
	
	const char * key;
	const char * val;
	
	GetArgByIndex(2, &kValue);
	pObj->pMmValue->ValueToStringPtr(&kValue, &key);
	
	GetArgByIndex(3, &vValue);
	pObj->pMmValue->ValueToStringPtr(&vValue, &val);
	
	p.set_parameter(key, val);
	
	pObj->pMmValue->ValueReleaseStringPtr(&kValue);
	pObj->pMmValue->ValueReleaseStringPtr(&vValue);
			
//	char key[32];
//	char val[32];
//
//	GetArgByIndex(2, &moaValue);
//	pObj->pMmValue->ValueToString( &moaValue, key, sizeof(key));
//	GetArgByIndex(3, &moaValue);
//	pObj->pMmValue->ValueToString( &moaValue, val, sizeof(val));
//	p.set_parameter(key, val);
	
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// SET_VALUE // p.set_value("pagewidth",600);
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_set_value(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	char key[32];
	double val;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, key, sizeof(key));
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &val);

	p.set_value(key, val);
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// GET_VALUE // dpi_x = p.get_value("resx", image)
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_get_value(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	char key[32];
	//double val;
	long val;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, key, sizeof(key));

	if (callPtr->nargs>2){
		GetArgByIndex(3, &moaValue);
		//pObj->pMmValue->ValueToFloat( &moaValue, &val);
		pObj->pMmValue->ValueToInteger( &moaValue, &val);
	}else val=0;

	float ret = p.get_value(key, (double)val);
	pObj->pMmValue->FloatToValue( ret, &callPtr->resultValue);

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// OPEN
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_open(PMoaDrCallInfo callPtr)
{
	MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	long strLen=0;
	char outputFilename[MAX_PATH + 1];

	// GET OUTPUT FILENAME
	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueStringLength(&moaValue,&strLen);
	if (strLen==0) {
		if (dbg) dbgs("Error: empty filename!");
		err = OUTPUT_ERR;
		pObj->pMmValue->IntegerToValue(err, &callPtr->resultValue);
		return kMoaErr_NoErr;
	};
	pObj->pMmValue->ValueToString( &moaValue, outputFilename, sizeof(outputFilename));

	// OPEN NEW PDF FILE
	if (p.open(outputFilename) == -1) {
		if (dbg) dbgs("Error: text is empty!");
		err = INIT_ERR;
		pObj->pMmValue->IntegerToValue(err, &callPtr->resultValue);
		return kMoaErr_NoErr;
	}

	return kMoaErr_NoErr;
}


//---------------------------------------------------------------
// CLOSE
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_close(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	p.close();
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// BEGIN_PAGE
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_begin_page(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};

	double w, h;

	if (callPtr->nargs>2){
		GetArgByIndex(2, &moaValue);
		pObj->pMmValue->ValueToFloat( &moaValue, &w);
		GetArgByIndex(3, &moaValue);
		pObj->pMmValue->ValueToFloat( &moaValue, &h);
	}else{
		w = (float) a4_width;
		h = (float) a4_height;
	}
	p.begin_page(w, h);
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// END_PAGE
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_end_page(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};

	p.end_page();
	return kMoaErr_NoErr;
}


//###########################################################################
// TEXT
//###########################################################################

//---------------------------------------------------------------
// FINDFONT
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_findfont(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	char fontname[256];
	char encoding[9];
	long opt;

	int font;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, fontname, sizeof(fontname));

	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, encoding, sizeof(encoding));

	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &opt);

	try {
	//	dbgs("TRY");

		// Change "host" encoding to "winansi" or whatever you need! //Helvetica-Bold
		font = p.findfont(fontname, encoding, opt);
		pObj->pMmValue->IntegerToValue(font, &callPtr->resultValue);

	}catch(PDFlib::Exception){//PDFlib::Exception &ex

	//	if (dbg) dbgs(ex.get_message().c_str());
	//	pObj->pMmValue->IntegerToValue(0, &callPtr->resultValue);
	//	return kMoaErr_NoErr;
	}

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// SETFONT
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_setfont(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};

	long font;
	double fontsize;
	
	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &font);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &fontsize);

	p.setfont(font, fontsize);
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// SET_TEXT_POS
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_set_text_pos(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	long x, y;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &x);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &y);
	p.set_text_pos(x, y);
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// SHOW
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_show(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	long len;
	char *text;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueStringLength(&moaValue,&len);
	text = (char*) malloc(len+1);
	pObj->pMmValue->ValueToString( &moaValue, text, len+1);

	p.show(text);
	free(text);
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// SHOW_XY
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_show_xy(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	long len;
	char *text;
	double x,y;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueStringLength(&moaValue,&len);
	text = (char*) malloc(len+1);
	pObj->pMmValue->ValueToString( &moaValue, text, len+1);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &x);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &y);
	p.show_xy(text,x,y);
	free(text);
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// CONTINUE_TEXT
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_continue_text(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	long len;
	char *text;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueStringLength(&moaValue,&len);
	text = (char*) malloc(len+1);
	pObj->pMmValue->ValueToString( &moaValue, text, len+1);
	p.continue_text(text);
	free(text);
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// SHOW_BOXED
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_show_boxed(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	long len;
	char *text;
	double x,y,w,h;
	char mode[12];
	char feature[6];

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueStringLength(&moaValue,&len);
	text = (char*) malloc(len+1);
	pObj->pMmValue->ValueToString( &moaValue, text, len+1);

	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &x);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &y);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &w);
	GetArgByIndex(6, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &h);
	GetArgByIndex(7, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, mode, sizeof(mode));
	GetArgByIndex(8, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, feature, sizeof(feature));
	p.show_boxed(text,x,y,w,h,mode,feature);
	free(text);
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// STRINGWIDTH
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_stringwidth(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	long len;
	char *text;
	long font;
	double fontsize;
	float w;
	
	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueStringLength(&moaValue,&len);
	text = (char*) malloc(len+1);
	pObj->pMmValue->ValueToString( &moaValue, text, len+1);

	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &font);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &fontsize);

	w=p.stringwidth(text,font,fontsize);
	pObj->pMmValue->FloatToValue(w, &callPtr->resultValue);
	free(text);
	return kMoaErr_NoErr;
}


//###########################################################################
// COLOR
//###########################################################################

//---------------------------------------------------------------
// SETCOLOR
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_setcolor(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	char type[7];
	char colorspace[8];
	double c1,c2,c3,c4;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, type, sizeof(type));
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, colorspace, sizeof(colorspace));
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &c1);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &c2);
	GetArgByIndex(6, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &c3);
	GetArgByIndex(7, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &c4);

	p.setcolor(type,colorspace,c1,c2,c3,c4);

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// MAKESPOTCOLOR
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_makespotcolor(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	char spotname[126];
	int spothandle;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, spotname, sizeof(spotname));
	spothandle = p.makespotcolor(spotname,strlen(spotname));
	pObj->pMmValue->IntegerToValue(spothandle, &callPtr->resultValue);
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// BEGIN_PATTERN
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_begin_pattern(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double w,h,xstep,ystep;
	long painttype;
	int patternhandle;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &w);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &h);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &xstep);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &ystep);
	GetArgByIndex(6, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &painttype);

	//dbgs("PATT");
	//return 0;

	//patternhandle = p.begin_pattern(w,h,xstep,ystep,painttype);
	patternhandle = p.begin_pattern(10.0,10.0,10.0,10.0, 2);
	//dbgi(patternhandle);
	//pObj->pMmValue->IntegerToValue(patternhandle, &callPtr->resultValue);
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// END_PATTERN
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_end_pattern(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	
	p.end_pattern();
	return kMoaErr_NoErr;
}


//###########################################################################
// IMAGE
//###########################################################################

//---------------------------------------------------------------
// OPEN_IMAGE_FILE
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_open_image_file(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	char format[5];
	char filename[MAX_PATH + 1];
	char stringparam[11];
	long intparam;
	int img;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, format, sizeof(format));
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, filename, sizeof(filename));
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, stringparam, sizeof(stringparam));
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &intparam);

	img = p.open_image_file(format,replace(filename,"\\","\\\\"),stringparam,intparam);
	pObj->pMmValue->IntegerToValue(img, &callPtr->resultValue);
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// OPEN_IMAGE
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_open_image(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	MoaMmValue pImage;
	MoaMmImageInfo imgInfo;
	PMoaVoid pPixels;

	long type=0;
	long length;
	char *str;
	int components;
	int x,y;
	long i=0;
	int img;

	// IMAGE
	GetArgByIndex(2, &pImage);
	pObj->pMmValue->ValueType(&pImage,&type);
	if (type!=21) {
		if (dbg) dbgs("Error: No image supplied!");
		pObj->pMmValue->IntegerToValue(IMG_ERR, &callPtr->resultValue);
		return kMoaErr_NoErr;
	}
	pObj->pMmImage->GetImageInfo(&pImage, &imgInfo);

//int PDF_open_image(PDF *p, const char *type, const char *source, const char *data,
//long length, int width, int height, int components, int bpc, const char *params)

	// RGB
	if (imgInfo.iTotalDepth>=24){
		components=3;
		length = imgInfo.iWidth * imgInfo.iHeight * 3;
		pObj->pMmImage->LockPixels (&pImage, &pPixels);
		char *pBits = (char *) pPixels;
		str = (char*) malloc(length+1);
		*str = 0;
		for (y = imgInfo.iHeight-1; y >= 0; y--)	{
			register int ymal = y * imgInfo.iRowBytes;
			for (x = 0; x < imgInfo.iWidth; x++){
				register int x4 = 4 * x;
				str[i++]=pBits[x4 + 2 + ymal]; // red
				str[i++]=pBits[x4 + 1 + ymal]; // green
				str[i++]=pBits[x4 + 0 + ymal]; //blue
			}
		}
	} else if (imgInfo.iTotalDepth==8){ 	// 8 BIT
		components=1;
		length = imgInfo.iWidth * imgInfo.iHeight;
		pObj->pMmImage->LockPixels (&pImage, &pPixels);
		char *pBits = (char *) pPixels;
		str = (char*) malloc(length+1);
		*str = 0;
		for (y = imgInfo.iHeight-1; y >= 0; y--)	{
			register int ymal = y * imgInfo.iRowBytes;
			for (x = 0; x < imgInfo.iWidth; x++){
				str[i++]=pBits[x + ymal]; // red
			}
		}
	} else { // other depths not supported (yet)
		if (dbg) dbgs("Error: Wrong type of image!");
		pObj->pMmValue->IntegerToValue(IMG_ERR, &callPtr->resultValue);
		return kMoaErr_NoErr;
	}

	img = p.open_image("raw", "memory", str, length, imgInfo.iWidth, imgInfo.iHeight, components, 8, "");

	pObj->pMmImage->UnlockPixels (&pImage);
	pObj->pMmValue->IntegerToValue(img, &callPtr->resultValue);
	free(str);

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// PLACE_IMAGE
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_place_image(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	long img;
	double x,y,s;
	
	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &img);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &x);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &y);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &s);

	p.place_image(img, x, y, s);
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// ADD_IMAGE_FILE
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_add_image_file(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	char format[5];
	char filename[MAX_PATH + 1];
	double x,y,s;
	int img;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, format, sizeof(format));
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, filename, sizeof(filename));
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &x);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &y);
	GetArgByIndex(6, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &s);

	img = p.open_image_file(format,replace(filename,"\\","\\\\"),"",0);
	p.place_image(img, x, y, s);
	p.close_image(img);
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// ADD_IMAGE
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_add_image(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	MoaMmValue pImage;
	MoaMmImageInfo imgInfo;
	PMoaVoid pPixels;

	long type=0;
	double ix,iy;
	long length;
	char *str;
	int components;
	int x,y;
	long i=0;
	int img;

	// IMAGE
	GetArgByIndex(2, &pImage);
	pObj->pMmValue->ValueType(&pImage,&type);
	if (type!=21) {
		if (dbg) dbgs("Error: No image supplied!");
		pObj->pMmValue->IntegerToValue(IMG_ERR, &callPtr->resultValue);
		return kMoaErr_NoErr;
	}
	pObj->pMmImage->GetImageInfo(&pImage, &imgInfo);

	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &ix);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &iy);

//int PDF_open_image(PDF *p, const char *type, const char *source, const char *data,
//long length, int width, int height, int components, int bpc, const char *params)

	// RGB
	if (imgInfo.iTotalDepth>=24){
		components=3;
		length = imgInfo.iWidth * imgInfo.iHeight * 3;
		pObj->pMmImage->LockPixels (&pImage, &pPixels);
		char *pBits = (char *) pPixels;
		str = (char*) malloc(length+1);
		*str = 0;
		for (y = imgInfo.iHeight-1; y >= 0; y--)	{
			register int ymal = y * imgInfo.iRowBytes;
			for (x = 0; x < imgInfo.iWidth; x++){
				register int x4 = 4 * x;
				str[i++]=pBits[x4 + 2 + ymal]; // red
				str[i++]=pBits[x4 + 1 + ymal]; // green
				str[i++]=pBits[x4 + 0 + ymal]; //blue
			}
		}
	} else if (imgInfo.iTotalDepth==8){ 	// 8 BIT
		components=1;
		length = imgInfo.iWidth * imgInfo.iHeight;
		pObj->pMmImage->LockPixels (&pImage, &pPixels);
		char *pBits = (char *) pPixels;
		str = (char*) malloc(length+1);
		*str = 0;
		for (y = imgInfo.iHeight-1; y >= 0; y--)	{
			register int ymal = y * imgInfo.iRowBytes;
			for (x = 0; x < imgInfo.iWidth; x++){
				str[i++]=pBits[x + ymal]; // red
			}
		}
	} else { // other depths not supported (yet)
		if (dbg) dbgs("Error: Wrong type of image!");
		pObj->pMmValue->IntegerToValue(IMG_ERR, &callPtr->resultValue);
		return kMoaErr_NoErr;
	}

	img = p.open_image("raw", "memory", str, length, imgInfo.iWidth, imgInfo.iHeight, components, 8, "");
	p.place_image(img, ix, iy, 1);
	p.close_image(img);

	pObj->pMmImage->UnlockPixels (&pImage);
	free(str);

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// CLOSE_IMAGE
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_close_image(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	long img;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &img);
	p.close_image(img);

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// BEGIN_TEMPLATE
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_begin_template(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double w,h;
	long templ;
	
	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &w);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &h);

	templ=p.begin_template(w,h);
	pObj->pMmValue->IntegerToValue(templ, &callPtr->resultValue);
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// END_TEMPLATE
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_end_template(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	p.end_template();
	return kMoaErr_NoErr;
}


//###########################################################################
// HYPERTEXT
//###########################################################################

//---------------------------------------------------------------
// SET_INFO
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_set_info(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	char str1[256];
	char str2[256];

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, str1, sizeof(str1));
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, str2, sizeof(str2));
	p.set_info(str1, str2);
	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// ADD_LOCALLINK
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_add_locallink(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double llx, lly, urx, ury;
	long page;
	char dest[10];

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &llx);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &lly);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &urx);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &ury);
	GetArgByIndex(6, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &page);
	GetArgByIndex(7, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, dest, sizeof(dest));

	p.add_locallink(llx,lly,urx,ury,page,dest);

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// ADD_WEBLINK
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_add_weblink(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double llx, lly, urx, ury;
	char url[256];

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &llx);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &lly);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &urx);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &ury);
	GetArgByIndex(6, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, url, sizeof(url));

	p.add_weblink(llx,lly,urx,ury,url);

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// ADD_LAUNCHLINK
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_add_launchlink(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double llx, lly, urx, ury;
	char filename[MAX_PATH + 1];

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &llx);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &lly);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &urx);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &ury);
	GetArgByIndex(6, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, filename, sizeof(filename));

	p.add_launchlink(llx,lly,urx,ury,replace(filename,"\\","\\\\"));

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// ADD_PDFLINK
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_add_pdflink(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double llx, lly, urx, ury;
	char filename[MAX_PATH + 1];
	long page;
	char dest[10];

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &llx);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &lly);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &urx);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &ury);
	GetArgByIndex(6, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, filename, sizeof(filename));
	GetArgByIndex(7, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &page);
	GetArgByIndex(8, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, dest, sizeof(dest));

	p.add_pdflink(llx,lly,urx,ury,replace(filename,"\\","\\\\"),page,dest);

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// ADD_NOTE
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_add_note(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double llx, lly, urx, ury;
	char *contents;
	long contLen;
	char title[256];
	char icon[13];
	long openInt;
	bool open;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &llx);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &lly);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &urx);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &ury);

	GetArgByIndex(6, &moaValue);
	pObj->pMmValue->ValueStringLength(&moaValue,&contLen);
	//if (contLen>0) {
		contents = (char*) malloc(contLen+1);
		pObj->pMmValue->ValueToString( &moaValue, contents, contLen+1);
	//}

	GetArgByIndex(7, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, title, sizeof(title));
	GetArgByIndex(8, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, icon, sizeof(icon));
	GetArgByIndex(9, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &openInt);
	open=(openInt>0);

	p.add_note(llx,lly,urx,ury,contents,title,icon,open);

	free(contents);

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// ADD_BOOKMARK
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_add_bookmark(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	char text[256];
	long parent;
	long openInt;
	bool open;
	int bm;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, text, sizeof(text));

	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &parent);

	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &openInt);
	open=(openInt>0);

	bm=p.add_bookmark(text,parent,open);
	pObj->pMmValue->IntegerToValue(bm, &callPtr->resultValue);

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// SET_BORDER_STYLE
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_set_border_style(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	char style[7];
	double width;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, style, sizeof(style));

	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &width);

	p.set_border_style(style,width);

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// SET_BORDER_COLOR
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_set_border_color(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double r,g,b;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &r);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &g);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &b);

	p.set_border_color(r,g,b);

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// SET_BORDER_DASH
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_set_border_dash(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double d1,d2;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &d1);

	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &d2);

	p.set_border_dash(d1,d2);

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// ATTACH_FILE
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_attach_file(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double llx, lly, urx, ury;
	char filename[MAX_PATH + 1];
	char desc[256];
	char author[256];
	char mime[80];
	char icon[10];

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &llx);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &lly);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &urx);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &ury);
	GetArgByIndex(6, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, filename, sizeof(filename));

	GetArgByIndex(7, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, desc, sizeof(desc));
	GetArgByIndex(8, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, author, sizeof(author));
	GetArgByIndex(9, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, mime, sizeof(mime));
	GetArgByIndex(10, &moaValue);
	pObj->pMmValue->ValueToString( &moaValue, icon, sizeof(icon));

	p.attach_file(llx,lly,urx,ury,replace(filename,"\\","\\\\"),desc,author,mime,icon);

	return kMoaErr_NoErr;
}

//---------------------------------------------------------------
// ADD_THUMBNAIL
//---------------------------------------------------------------
MoaError CPDF_IMoaMmXScript::XX_add_thumbnail(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	long img;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &img);

	p.add_thumbnail(img);

	return kMoaErr_NoErr;
}


//###########################################################################
// GRAPHICS
//###########################################################################

MoaError CPDF_IMoaMmXScript::XX_save(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	p.save();
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_restore(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	p.restore();
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_translate(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double x,y;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &x);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &y);
	p.translate(x,y);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_scale(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double x,y;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &x);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &y);
	p.scale(x,y);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_rotate(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double phi;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &phi);
	p.rotate(phi);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_skew(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double alpha,beta;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &alpha);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &beta);
	p.skew(alpha,beta);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_concat(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double a,b,c,d,e,f;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &a);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &b);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &c);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &d);
	GetArgByIndex(6, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &e);
	GetArgByIndex(7, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &f);
	p.concat(a,b,c,d,e,f);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_setdash(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double b,w;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &b);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &w);
	p.setdash(b,w);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_setpolydash(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_setflat(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double flat;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &flat);
	p.setflat(flat);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_setlinejoin(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	long join;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &join);
	p.setlinejoin(join);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_setlinecap(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	long cap;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToInteger( &moaValue, &cap);
	p.setlinecap(cap);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_setmiterlimit(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double miter;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &miter);
	p.setmiterlimit(miter);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_setlinewidth(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double width;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &width);
	p.setlinewidth(width);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_moveto(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double x,y;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &x);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &y);
	p.moveto(x,y);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_lineto(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double x,y;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &x);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &y);
	p.lineto(x,y);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_curveto(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double x1,x2,x3,y1,y2,y3;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &x1);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &y1);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &x2);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &y2);
	GetArgByIndex(6, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &x3);
	GetArgByIndex(7, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &y3);
	p.curveto(x1,y1,x2,y2,x3,y3);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_circle(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double x,y,r;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &x);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &y);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &r);
	p.circle(x,y,r);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_arc(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double x,y,r,a1,a2;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &x);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &y);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &r);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &a1);
	GetArgByIndex(6, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &a2);
	p.arc(x,y,r,a1,a2);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_arcn(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double x,y,r,a1,a2;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &x);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &y);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &r);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &a1);
	GetArgByIndex(6, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &a2);
	p.arcn(x,y,r,a1,a2);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_rect(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	MoaMmValue moaValue = {0};
	double x,y,w,h;

	GetArgByIndex(2, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &x);
	GetArgByIndex(3, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &y);
	GetArgByIndex(4, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &w);
	GetArgByIndex(5, &moaValue);
	pObj->pMmValue->ValueToFloat( &moaValue, &h);
	p.rect(x,y,w,h);
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_closepath(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	p.closepath();
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_stroke(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	p.stroke();
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_closepath_stroke(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	p.closepath_stroke();
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_fill(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	p.fill();
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_fill_stroke(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	p.fill_stroke();
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_closepath_fill_stroke(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	p.closepath_fill_stroke();
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_clip(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	p.clip();
	return kMoaErr_NoErr;
}

MoaError CPDF_IMoaMmXScript::XX_endpath(PMoaDrCallInfo callPtr)
{
	//MoaError err = kMoaErr_NoErr;
	p.endpath();
	return kMoaErr_NoErr;
}



/*****************************************************************************
 *  CLASS INTERFACE(S)
 *  ------------------
 *  The interface(s) implemented by your MOA class are specified here.  Note
 *	that at least one class in your Xtra should implement the IMoaRegister
 *	interface.
 *  NOTE: Because C++ does not use a lpVtbl to reference an interface's
 *	methods, the actual method declaration is done in the .h file.
 *
 *  Syntax:
 *  BEGIN_DEFINE_CLASS_INTERFACE(<class-name>, <interface-name>) 
 ****************************************************************************/ 
BEGIN_DEFINE_CLASS_INTERFACE(CPDF, IMoaMmXScript)
END_DEFINE_CLASS_INTERFACE

#ifdef USING_INIT_FROM_DICT
BEGIN_DEFINE_CLASS_INTERFACE(CPDF, IMoaInitFromDict)
END_DEFINE_CLASS_INTERFACE
#endif

#ifdef USING_NOTIFICATION_CLIENT
BEGIN_DEFINE_CLASS_INTERFACE(CPDF, IMoaNotificationClient)
END_DEFINE_CLASS_INTERFACE
#endif


/*****************************************************************************
 *  CREATE AND DESTROY METHODS
 *  --------------------------
 *  Every interface and class has an associated 'Create' and 'Destroy' pair.
 *  'Create' methods are typically used to acquire interface(s), allocate 
 *  memory, and intialize variables. 'Destroy' methods are typically used to 
 *  release interfaces and free memory.
 *
 * NOTE:  In C++, the local variable 'This' is provided implicitly within 
 * a method implementation.  Thus, there is no need explicitly declare 'This' 
 * as a function parameter. However, this implementation detail doesnt apply 
 * to the MOA class creator and destructor functions, which are standard C 
 * functions, coded exactly as in like they are in C examples.  
 *
 * Class Syntax:
 * STDMETHODIMP MoaCreate_<class-name>(<class-name> FAR * This)
 * STDMETHODIMP MoaDestroy_<class-name>(<class-name> FAR * This)
 *
 * Interface Syntax:
 * <class_name>_<if_name>::<class_name>_<if_name>(MoaError FAR * pErr)
 * <class_name>_<if_name>::~<class_name>_<if_name>()
 ****************************************************************************/ 

/* ------------------------------------------------------ MoaCreate_CPDF */
STDMETHODIMP MoaCreate_CPDF(CPDF FAR * This)
{

	// variable declarations
	MoaError err = kMoaErr_NoErr;

	// Set up all our interfaces
	This->pCallback->QueryInterface(&IID_IMoaHandle, (PPMoaVoid)&This->pHandle);
	This->pCallback->QueryInterface(&IID_IMoaAppInfo, (PPMoaVoid)&This->pAppInfo);
	This->pCallback->MoaCreateInstance(&CLSID_CMoaFile2, &IID_IMoaFile2,(PPMoaVoid)&This->pMoaFile);
	This->pCallback->QueryInterface(&IID_IMoaMmValue, (PPMoaVoid)&This->pMmValue);
	pVal = This->pMmValue;
	This->pCallback->QueryInterface(&IID_IMoaMmImage, (PPMoaVoid)&This->pMmImage);
	This->pCallback->QueryInterface(&IID_IMoaMmUtils2, (PPMoaVoid)&This->pMmUtils2);
	This->pCallback->QueryInterface(&IID_IMoaMmList, (PPMoaVoid)&This->pMmList);
	This->pCallback->QueryInterface(&IID_IMoaMmColor, (PPMoaVoid)&This->pMmColor);
#ifdef WINDOWS
	This->pCallback->QueryInterface(&IID_IMoaMmWndWin, (PPMoaVoid)&This->pMmWndWin);
	if(!This->pMmWndWin)
	{
		err = kMoaErr_BadInterface;
		goto exit_gracefully;
	}
#endif
	This->pCallback->QueryInterface(&IID_IMoaDrPlayer, (PPMoaVoid)&This->pDrPlayer);
	pPlayer=This->pDrPlayer;
	This->pCallback->QueryInterface(&IID_IMoaDrUtils, (PPMoaVoid)&This->pDrUtils);

	// If we failed to get any of these interfaces, bail out
	if( !This->pHandle || !This->pAppInfo || !This->pMoaFile || !This->pMmValue || 
			!This->pMmUtils2 || !This->pMmList || !This->pDrPlayer || !This->pDrUtils
			|| !This->pMmImage			)
	{
		err = kMoaErr_BadInterface;
		goto exit_gracefully;
	}

	This->pMoaStream = NULL;
	This->pMmGC = NULL;
	This->pDrMovie = NULL;
	This->pDrCast = NULL;
	This->pDrCastMem = NULL;
	This->pDrScore = NULL;
	This->pDrSprite = NULL;	

exit_gracefully:

	return(err);
}

/* ----------------------------------------------------- MoaDestroy_CPDF */
STDMETHODIMP_(void) MoaDestroy_CPDF(CPDF FAR * This)
{
	// Release all saved interfaces.

	if (This->pHandle) This->pHandle->Release();
	This->pHandle = NULL;

	if (This->pAppInfo) This->pAppInfo->Release();
	This->pAppInfo = NULL;

	if (This->pMmValue) This->pMmValue->Release();
	This->pMmValue = NULL;

	if (This->pMmUtils2) This->pMmUtils2->Release();
	This->pMmUtils2 = NULL;

	if (This->pMmList) This->pMmList->Release();
	This->pMmList = NULL;

	if (This->pMoaFile) This->pMoaFile->Release();
	This->pMoaFile = NULL;

#ifdef WINDOWS
	if (This->pMmWndWin) This->pMmWndWin->Release();
	This->pMmWndWin = NULL;
#endif
	if (This->pDrPlayer) This->pDrPlayer->Release();
	This->pDrPlayer = NULL;

	if (This->pDrUtils) This->pDrUtils->Release();
	This->pDrUtils = NULL;

//TEST
	//if (This->pMuiAlert) This->pMuiAlert->Release();
	//This->pMuiAlert = NULL;

	///p.close(); !!!

	//try {p.close();} catch(PDFlib::Exception &ex){dbgs("NO CLOSE");return;}
    //PDF_TRY	::PDF_close(p);
    //PDF_CATCH;
	
	//try {	PDF_close(p);	}
	//catch(PDFlib::Exception &ex){dbgs("ERR");return;}

	return;
}

/* ----------------------------------- CPDF_IMoaMmXScript Create/Destroy */
CPDF_IMoaMmXScript::CPDF_IMoaMmXScript(MoaError FAR * pErr)
	{ *pErr = (kMoaErr_NoErr); }
CPDF_IMoaMmXScript::~CPDF_IMoaMmXScript() {}

#ifdef USING_INIT_FROM_DICT
/* -------------------------------- CPDF_IMoaInitFromDict Create/Destroy */
CPDF_IMoaInitFromDict::CPDF_IMoaInitFromDict(MoaError FAR * pErr)
	{ *pErr = (kMoaErr_NoErr); }
CPDF_IMoaInitFromDict::~CPDF_IMoaInitFromDict() {}
#endif

#ifdef USING_NOTIFICATION_CLIENT
/* -------------------------- CPDF_IMoaNotificationClient Create/Destroy */
CPDF_IMoaNotificationClient::CPDF_IMoaNotificationClient(MoaError FAR * pErr)
	{ *pErr = (kMoaErr_NoErr); }
CPDF_IMoaNotificationClient::~CPDF_IMoaNotificationClient() {}
#endif

/*****************************************************************************
 *  METHOD IMPLEMENTATION(S)
 *  ------------------------
 *  This is where the methods to be defined by your MOA class are implemented.
 *  The bulk of the work in implementing Xtras is done here.  NOTE: 'This' is 
 *  implemented implicitly in C++, therefore it isn't used in the argument-
 *	list.
 *
 *  Syntax:
 *  STDMETHODIMP <class-name>_<interface-name>::<method-name>(<argument-list>)
 ****************************************************************************/ 

/* -------------------------------------------- CPDF_IMoaMmXScript::Call */
STDMETHODIMP CPDF_IMoaMmXScript::Call(PMoaMmCallInfo callPtr)
{

	// variable declarations
	MoaError err = kMoaErr_NoErr;
	
	// Get the active movie 
	if ((err = pObj->pDrPlayer->GetActiveMovie(&pObj->pDrMovie)) != kMoaErr_NoErr) 
		goto exit_gracefully;
	
	// Get a score access interface for the movie
	if ((err = pObj->pDrMovie->GetScoreAccess(&pObj->pDrScore)) != kMoaErr_NoErr) 
		goto exit_gracefully;

	switch	( callPtr->methodSelector ) 
	{
// GENERAL
		case m_new:
			//err = XX_new(callPtr);
		break;
		case m_set_parameter:
			err = XX_set_parameter(callPtr);
		break;
		case m_set_value:
			err = XX_set_value(callPtr);
		break;
		case m_get_value:
			err = XX_get_value(callPtr);
		break;
		case m_open:
			err = XX_open(callPtr);
		break;
		case m_close:
			err = XX_close(callPtr);
		break;
		case m_begin_page:
			err = XX_begin_page(callPtr);
		break;
		case m_end_page:
			err = XX_end_page(callPtr);
		break;

// TEXT
		case m_findfont:
			err = XX_findfont(callPtr);
		break;
		case m_setfont:
			err = XX_setfont(callPtr);
		break;
		case m_set_text_pos:
			err = XX_set_text_pos(callPtr);
		break;
		case m_show:
			err = XX_show(callPtr);
		break;
		case m_show_xy:
			err = XX_show_xy(callPtr);
		break;
		case m_continue_text:
			err = XX_continue_text(callPtr);
		break;
		case m_show_boxed:
			err = XX_show_boxed(callPtr);
		break;
		case m_stringwidth:
			err = XX_stringwidth(callPtr);
		break;

// COLOR
		case m_setcolor:
			err = XX_setcolor(callPtr);
		break;
		case m_makespotcolor:
			err = XX_makespotcolor(callPtr);
		break;
		case m_begin_pattern:
			err = XX_begin_pattern(callPtr);
		break;
		case m_end_pattern:
			err = XX_end_pattern(callPtr);
		break;

// IMAGE
		case m_open_image_file:
			err = XX_open_image_file(callPtr);
		break;
		case m_open_image:
			err = XX_open_image(callPtr);
		break;
		case m_place_image:
			err = XX_place_image(callPtr);
		break;
		case m_add_image_file:
			err = XX_add_image_file(callPtr);
		break;
		case m_add_image:
			err = XX_add_image(callPtr);
		break;
		case m_close_image:
			err = XX_close_image(callPtr);
		break;
		case m_begin_template:
			err = XX_begin_template(callPtr);
		break;
		case m_end_template:
			err = XX_end_template(callPtr);
		break;

// HYPERTEXT
		case m_set_info:
			err = XX_set_info(callPtr);
		break;
		case m_add_locallink:
			err = XX_add_locallink(callPtr);
		break;
		case m_add_weblink:
			err = XX_add_weblink(callPtr);
		break;
		case m_add_launchlink:
			err = XX_add_launchlink(callPtr);
		break;
		case m_add_pdflink:
			err = XX_add_pdflink(callPtr);
		break;
		case m_add_note:
			err = XX_add_note(callPtr);
		break;
		case m_add_bookmark:
			err = XX_add_bookmark(callPtr);
		break;
		case m_set_border_style:
			err = XX_set_border_style(callPtr);
		break;
		case m_set_border_color:
			err = XX_set_border_color(callPtr);
		break;
		case m_set_border_dash:
			err = XX_set_border_dash(callPtr);
		break;
		case m_attach_file:
			err = XX_attach_file(callPtr);
		break;
		case m_add_thumbnail:
			err = XX_add_thumbnail(callPtr);
		break;

// GRAPHICS
		case m_save:
		  err = XX_save(callPtr);
		break;  
		case m_restore:
		  err = XX_restore(callPtr);
		break; 
		case m_translate:
		 err = XX_translate(callPtr);
		break; 
		case m_scale:
		  err = XX_scale(callPtr);
		break; 
		case m_rotate:
		  err = XX_rotate(callPtr);
		break; 
		case m_skew:
		  err = XX_skew(callPtr);
		break;  
		case m_concat:
		  err = XX_concat(callPtr);
		break; 
		case m_setdash:
		  err = XX_setdash(callPtr);
		break; 
		case m_setpolydash:
		 err = XX_setpolydash(callPtr);
		break; 
		case m_setflat:
		  err = XX_setflat(callPtr);
		break; 
		case m_setlinejoin:
		 err = XX_setlinejoin(callPtr);
		break; 
		case m_setlinecap:
		 err = XX_setlinecap(callPtr);
		break; 
		case m_setmiterlimit:
		 err = XX_setmiterlimit(callPtr);
		break; 
		case m_setlinewidth:
		 err = XX_setlinewidth(callPtr);
		break; 
		case m_moveto:
		  err = XX_moveto(callPtr);
		break; 
		case m_lineto:
		  err = XX_lineto(callPtr);
		break; 
		case m_curveto:
		  err = XX_curveto(callPtr);
		break; 
		case m_circle:
		  err = XX_circle(callPtr);
		break; 
		case m_arc:
		  err = XX_arc(callPtr);
		break;  
		case m_arcn:
		  err = XX_arcn(callPtr);
		break;  
		case m_rect:
		  err = XX_rect(callPtr);
		break;  
		case m_closepath:
		 err = XX_closepath(callPtr);
		break; 
		case m_stroke:
		  err = XX_stroke(callPtr);
		break; 
		case m_closepath_stroke:
		 err = XX_closepath_stroke(callPtr);
		break; 
		case m_fill:
		  err = XX_fill(callPtr);
		break;  
		case m_fill_stroke:
		 err = XX_fill_stroke(callPtr);
		break; 
		case m_closepath_fill_stroke:
		 err = XX_closepath_fill_stroke(callPtr);
		break;
		case m_clip:
		  err = XX_clip(callPtr);
		break;  
		case m_endpath:
			err = XX_endpath(callPtr);
		break;
	}

exit_gracefully:
	// release the movie and score interfaces
	if(pObj->pDrMovie)
	{
		pObj->pDrMovie->Release();
		pObj->pDrMovie = NULL;
	}

	if(pObj->pDrScore)
	{
		pObj->pDrScore->Release();
		pObj->pDrScore = NULL;
	}

	return(err);
}

#ifdef USING_INIT_FROM_DICT
/* --------------------------------- CPDF_IMoaInitFromDict::InitFromDict */
STDMETHODIMP CPDF_IMoaInitFromDict::InitFromDict(PIMoaRegistryEntryDict pRegistryDict)
{
	UNUSED(pRegistryDict);
	
	/* variable declarations */
	//MoaError err = kMoaErr_NoErr;

	return(err);
}
#endif

#ifdef USING_NOTIFICATION_CLIENT
/* --------------------------------- CPDF_IMoaNotificationClient::Notify */
STDMETHODIMP CPDF_IMoaNotificationClient::Notify(ConstPMoaNotifyID nid, PMoaVoid pNData, PMoaVoid pRefCon)
{
	UNUSED(nid);
	UNUSED(pNData);
	UNUSED(pRefCon);
	
	/* variable declarations */
	//MoaError err = kMoaErr_NoErr;

	return(err);
}
#endif
