#ifndef _H_cscript
#define _H_cscript

/*****************************************************************************
 * Copyright  1994-1999 Macromedia, Inc.  All Rights Reserved
 *
 * You may utilize this source file to create and compile object code for use 
 * within products you create.  THIS CODE IS PROVIDED "AS IS", WITHOUT 
 * WARRANTY OF ANY KIND, AND MACROMEDIA DISCLAIMS ALL IMPLIED WARRANTIES 
 * INCLUDING, BUT NOT LIMITED TO, MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT.  IN NO EVENT WILL MACROMEDIA BE LIABLE TO YOU 
 * FOR ANY CONSEQUENTIAL, INDIRECT OR INCIDENTAL DAMAGES ARISING OUT OF YOUR 
 * USE OR INABILITY TO USE THIS CODE.
 *
 *	Name: PsxScrp.h
 *	
 * 	Purpose: Declarations of the CLSID, class instance variables, and  
 *           class interface(s) for the DrAccess Xtra's scripting class.
 *
 ****************************************************************************/ 

/*****************************************************************************
 *  INCLUDE FILE(S)
 *  ---------------
 *	This .h file should automatically include all the support files needed for
 *	this particular class. In addition, this file may include other .h files
 *	defining additional callback interfaces for use by a third party.   
 ****************************************************************************/ 
#ifndef _H_moaxtra		  
	#include "moaxtra.h"
#endif

#include "mmixscrp.h"
#include "moafile2.h"
#include "moastr2.h"
#include "mmiservc.h"
#include "driservc.h"
#include "mmiimage.h"
#include "mmivalue.h"
#include "mmiservc.h"
#include "mmiClr.h"

#include "mui.h"

#if defined(WINDOWS) && defined(WIN32)
//#include <winuser.h>  //  for GetStageRect
#endif

#ifdef MACINTOSH
	#include <windows.h>
	#include <string.h>
#endif

/*****************************************************************************
 *  CONFIGURATION DEFINE(S)
 *  -----------------------
 *	Uncomment any appropriate lines below to implement the indicated Xtra
 *	interfaces within this class.
 ****************************************************************************/ 
//#define USING_INIT_FROM_DICT
//#define USING_NOTIFICATION_CLIENT

/*****************************************************************************
 *	CLASS SPECIFIC DEFINE(S)
 *	-----------------------
 *	Any #define's specific to this class 
 ****************************************************************************/ 
#ifndef UNUSED
	#define UNUSED(x) x
#endif

//#define MYFILE_NAME  "myfile.txt"

/* some locally useful #defines etc. */

#define PROPBUF_SIZE	256
#define PROPNAME_SIZE	32
//#define MY_BUF_SIZE		32
#define MAXDOCOMMAND	1024
#define MAX_STRING_SIZE	255

/* Global to hold temporary argument values */

static	MoaMmValue	gTempArg;
                                
/*****************************************************************************
 *	CLSID
 *	-----
 *	The CLSID is a GUID that unquely identifies your MOA class.  To generate a
 *	GUID, use the genUID.app utility (Mac) or the GUIDGEN.EXE utility (Win).
 *	The following line will produce a pre-compiler error if not replaced with
 *	a valid CLSID.
 ****************************************************************************/ 
DEFINE_GUID(CLSID(CPDF), 
0x8e384daf, 0xffa1, 0x4545, 0xbf, 0x25, 0x3b, 0x14, 0xd9, 0x6a, 0xa3, 0xc1);


/*****************************************************************************
 *  CLASS INSTANCE VARIABLES
 *  ------------------------
 *  Class instance variable are variables whose scope is exclusive to the
 *  methods implemented by your MOA class.  Variables necessary for the
 *  implementation of your MOA class should be placed here.
 ****************************************************************************/ 
EXTERN_BEGIN_DEFINE_CLASS_INSTANCE_VARS(CPDF)
	PIMoaHandle					pHandle;
	PIMoaAppInfo				pAppInfo;
	PIMoaFile2					pMoaFile;
	PIMoaStream2				pMoaStream;
	PIMoaMmValue				pMmValue;
	PIMoaMmImage				pMmImage;
	PIMoaMmUtils2				pMmUtils2;
	PIMoaMmList					pMmList;
	PIMoaMmGC						pMmGC;

	PIMoaMmColor				pMmColor;

#ifdef WINDOWS
	PIMoaMmWndWin				pMmWndWin;
#endif
	PIMoaDrPlayer				pDrPlayer;
	PIMoaDrMovie				pDrMovie;
	PIMoaDrCast					pDrCast;
	PIMoaDrCastMem				pDrCastMem;
	PIMoaDrScoreAccess 			pDrScore;
	PIMoaDrScoreSprite 			pDrSprite;
	PIMoaDrUtils				pDrUtils;

	//TEST
	//PIMuiAlert				pMuiAlert;

EXTERN_END_DEFINE_CLASS_INSTANCE_VARS

/*****************************************************************************
 *  CLASS INTERFACE(S)
 *  ------------------
 *  The interface(s) implemented by your MOA class are specified here.  Note
 *	that at least one class in your Xtra should implement the IMoaRegister
 *	interface.
 *  NOTE: Because C++ does not use a lpVtbl to reference an interface's methods, 
 *  the actual method declaration is done here.
 *
 *  Syntax:
 *  EXTERN_BEGIN_DEFINE_CLASS_INTERFACE(<class-name>, <interface-name>) 
 *		EXTERN_DEFINE_METHOD(<return-type>, <method-name>,(<argument-list>)) 
 *	EXTERN_END_DEFINE_CLASS_INTERFACE
 ****************************************************************************/

EXTERN_BEGIN_DEFINE_CLASS_INTERFACE(CPDF, IMoaMmXScript)
	EXTERN_DEFINE_METHOD(MoaError, Call, (PMoaMmCallInfo))
   private:
/***** MISC *****/
//EXTERN_DEFINE_METHOD(MoaError, XX_new, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_set_parameter, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_set_value, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_get_value, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_open, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_close, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_begin_page, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_end_page, (PMoaDrCallInfo))

EXTERN_DEFINE_METHOD(MoaError, XX_findfont, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_setfont, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_set_text_pos, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_show, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_show_xy, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_continue_text, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_show_boxed, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_stringwidth, (PMoaDrCallInfo))

EXTERN_DEFINE_METHOD(MoaError, XX_setcolor, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_makespotcolor, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_begin_pattern, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_end_pattern, (PMoaDrCallInfo))

EXTERN_DEFINE_METHOD(MoaError, XX_open_image_file, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_open_image, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_place_image, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_add_image_file, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_add_image, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_close_image, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_begin_template, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_end_template, (PMoaDrCallInfo))

EXTERN_DEFINE_METHOD(MoaError, XX_set_info, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_add_locallink, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_add_weblink, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_add_launchlink, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_add_pdflink, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_add_note, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_add_bookmark, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_set_border_style, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_set_border_color, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_set_border_dash, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_attach_file, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_add_thumbnail, (PMoaDrCallInfo))

// GRAPHICS
EXTERN_DEFINE_METHOD(MoaError, XX_save, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_restore, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_translate, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_scale, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_rotate, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_skew, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_concat, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_setdash, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_setpolydash, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_setflat, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_setlinejoin, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_setlinecap, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_setmiterlimit, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_setlinewidth, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_moveto, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_lineto, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_curveto, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_circle, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_arc, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_arcn, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_rect, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_closepath, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_stroke, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_closepath_stroke, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_fill, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_fill_stroke, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_closepath_fill_stroke, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_clip, (PMoaDrCallInfo))
EXTERN_DEFINE_METHOD(MoaError, XX_endpath, (PMoaDrCallInfo))
EXTERN_END_DEFINE_CLASS_INTERFACE

#ifdef USING_INIT_FROM_DICT
EXTERN_BEGIN_DEFINE_CLASS_INTERFACE(CPDF, IMoaInitFromDict)
	EXTERN_DEFINE_METHOD(MoaError, InitFromDict, (PIMoaRegistryEntryDict))
EXTERN_END_DEFINE_CLASS_INTERFACE
#endif

#ifdef USING_NOTIFICATION_CLIENT
EXTERN_BEGIN_DEFINE_CLASS_INTERFACE(CPDF, IMoaNotificationClient)
	EXTERN_DEFINE_METHOD(MoaError, Notify, (ConstPMoaNotifyID, PMoaVoid, PMoaVoid))
EXTERN_END_DEFINE_CLASS_INTERFACE
#endif


// Method List...

enum 
{
m_new = 0,					/* standard */
m_set_parameter,
m_set_value,
m_get_value,
m_open,
m_close,
m_begin_page,
m_end_page,

m_findfont,
m_setfont,
m_set_text_pos,
m_show,
m_show_xy,
m_continue_text,
m_show_boxed,
m_stringwidth,

m_setcolor,
m_makespotcolor,
m_begin_pattern,
m_end_pattern,

m_open_image_file,
m_open_image,
m_place_image,
m_add_image_file,
m_add_image,
m_close_image,
m_begin_template,
m_end_template,

m_set_info,
m_add_locallink,
m_add_weblink,
m_add_launchlink,
m_add_pdflink,
m_add_note,
m_add_bookmark,
m_set_border_style,
m_set_border_color,
m_set_border_dash,
m_attach_file,
m_add_thumbnail,

m_save,
m_restore,
m_translate,
m_scale,
m_rotate,
m_skew,
m_concat,
m_setdash,
m_setpolydash,
m_setflat,
m_setlinejoin,
m_setlinecap,
m_setmiterlimit,
m_setlinewidth,
m_moveto,
m_lineto,
m_curveto,
m_circle,
m_arc,
m_arcn,
m_rect,
m_closepath,
m_stroke,
m_closepath_stroke,
m_fill,
m_fill_stroke,
m_closepath_fill_stroke,
m_clip,
m_endpath,
m_XXXX
};

#endif /* _H_cscript */
